Package net.snowflake.client.api.statement

## Interface SnowflakeStatement

    public interface SnowflakeStatement

This interface defines Snowflake specific APIs for Statement

### Method Summary

All Methods Instance Methods Abstract Methods
`ResultSet` `executeAsyncQuery​(String sql)` Execute SQL query asynchronously
`List<String>` `getBatchQueryIDs()`
`String` `getQueryID()`
`void` `setAsyncQueryTimeout​(int seconds)` Sets the query timeout when running an async query.
`void` `setBatchID​(String batchID)` Set batch ID
`void` `setParameter​(String name, Object value)` Set statement level parameter

### Method Detail

#### getQueryID

    String getQueryID()
               throws SQLException

Returns:
  the Snowflake query ID of the latest executed query (even failed one) or null when the last query ID is not available
Throws:
  `SQLException` - if an error is encountered

#### getBatchQueryIDs

    List<String> getBatchQueryIDs()
                           throws SQLException

Returns:
  the Snowflake query IDs of the latest executed batch queries
Throws:
  `SQLException` - if an error is encountered

#### setParameter

    void setParameter​(String name,
                      Object value)
               throws SQLException

Set statement level parameter

Parameters:
  `name` - parameter name
  `value` - parameter value
Throws:
  `SQLException` - if an error is encountered

#### setBatchID

    void setBatchID​(String batchID)

Set batch ID

Parameters:
  `batchID` - the batch ID

#### executeAsyncQuery

    ResultSet executeAsyncQuery​(String sql)
                         throws SQLException

Execute SQL query asynchronously

Parameters:
  `sql` - sql statement
Returns:
  ResultSet
Throws:
  `SQLException` - if @link{#executeQueryInternal(String, Map)} throws an exception

#### setAsyncQueryTimeout

    void setAsyncQueryTimeout​(int seconds)
                       throws SQLException

Sets the query timeout when running an async query.

Parameters:
  `seconds` - The number of seconds until timeout.
Throws:
  `SQLException` - if an error is encountered